
------ Feedbacks -- version 1 
function createObserverChart (terrame_object, attr_names)
	chart = Observer {
		subject = terrame_object,
		attributes = attr_names,
		curveLabels = attr_names,
		type = "chart"
	}
end

----
function createPlot (model)

	model.plot = Cell (model.values)
	createObserverChart (model.plot, model.attributes)
	model.plot:notify(0) 

end
------------------
function createTimer (model)

	model.timer = Timer {
		Event{time = 1, period = 1, action = function(ev)
			tempChanges(model)    -- 
			model.plot:notify(ev:getTime()) 
		end}
	}
end
-------------------

tempChanges = function (model)
	model.values.temperature1 = model.values.temperature1 - (model.values.temperature1 - 20)/10
	model.values.temperature2 = model.values.temperature2 - (model.values.temperature2 - 20)/10
	model.values.temperature3 = model.values.temperature3 - (model.values.temperature3 - 20)/10
end

-----------------

function run (model, time)
	model.timer:execute (time)
end

-----------
function SystemDynamicsModel(model)

	-- create Plot
	createPlot (model)

	-- timer
	createTimer (model)

	return model
end
---------
model =  SystemDynamicsModel {
	attributes    = { "temperature1", "temperature2", "temperature3"},
	values        = { temperature1 = 80, temperature2 = 20, temperature3 = 5 }
}
-----
run (model, 20)  -- executa o modelo em 8 passos de tempo